proc Dialog_Create {top title args} {
  global dialog
  if {[winfo exists $top]} {
    switch -- [wm state $top] {
      normal {
        raise $top
      }
      withdrawn -
      iconified {
        wm deiconify $top
        catch {wm geometry $top $dialog(geo,$top)}
      }
    }
    return 0
  } else {
    eval {toplevel $top} $args
    wm title $top $title
    return 1
  }
}

proc Dialog_Wait {top varName {focus {}}} {
  upvar $varName var
  bind $top <Destroy> [list set $varName $var]
  if {[string length $focus] == 0} {
    set focus $top
  }
  set old [focus -displayof $top]
  focus $focus
  catch {tkwait visibility $top}
  catch {grab $top}
  tkwait variable $varName
  catch {grab release $top}
  focus $old
}

proc Dialog_Dismiss {top} {
  global dialog
  catch {
    set dialog(geo,$top) [wm geometry $top]
    wm withdraw $top
  }
}
